<?php
    include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
    include_once(realpath(dirname(__FILE__)) . "/../../../classes/Venteprod.class.php");
    include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
    include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produit.class.php");
    include_once(realpath(dirname(__FILE__)) . "/../../../classes/Modules.class.php");

    class Icirelais extends PluginsTransports 
    {	
        const EXPEDITEUR_NOM = "ir_expediteur_nom";
        const EXPEDITEUR_AD1 = "ir_expediteur_ad_1";
        const EXPEDITEUR_CP = "ir_expediteur_cp";
        const EXPEDITEUR_VILLE = "ir_expediteur_ville";
        const EXPEDITEUR_RUE = "ir_expediteur_rue";
        const EXPEDITEUR_PAYS = "ir_expediteur_pays";
        const EXPEDITEUR_TEL = "ir_expediteur_tel";
        const EXPEDITEUR_EMAIL = "ir_expediteur_email";
        const EXPEDITEUR_TELPORT = "ir_expediteur_tel_port";

        const ASSURE_COLIS = "ir_assure_colis";

        const UNITE_POIDS = "ir_unite_poids";

        const PREFIXE   = 'ir_';

        var $id;
        var $commande;
        var $client;
        var $code_point;
        var $nom_point;
        var $adresse_point;
        var $cpostal_point;
        var $ville_point;
        var $expedition;

        var $days = array(
            1	=>	'Lundi',
            2	=>	'Mardi',
            3	=>	'Mercredi',
            4	=>	'Jeudi',
            5	=>	'Vendredi',
            6	=>	'Samedi',
            7	=>	'Dimanche'
        );

        var $table="commande_icirelais";
        var $bddvars = array("id", "commande", "client","code_point","nom_point","adresse_point","cpostal_point","ville_point","expedition");

        function Icirelais()
        {
            $this->PluginsTransports("Icirelais");
        }

        function init()
        {
            $query = mysql_query("CREATE TABLE `commande_icirelais` (
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
                `commande` INT NOT NULL ,
                `client` INT NOT NULL ,
                `code_point` TEXT NOT NULL ,
                `nom_point` TEXT NOT NULL ,
                `adresse_point` TEXT NOT NULL,
                `cpostal_point` TEXT NOT NULL,
                `ville_point` TEXT NOT NULL,
                `expedition` TEXT NOT NULL
                )");
            
            $this->ajout_desc("Icirelais", "Icirelais", "", 1);

            $this->create_var(self::EXPEDITEUR_NOM, 'nom');
            $this->create_var(self::EXPEDITEUR_AD1, 'adresse1');
            $this->create_var(self::EXPEDITEUR_CP, 'cpostal');
            $this->create_var(self::EXPEDITEUR_VILLE, 'ville');
            $this->create_var(self::EXPEDITEUR_RUE, 'rue');
            $this->create_var(self::EXPEDITEUR_PAYS, 'F');
            $this->create_var(self::EXPEDITEUR_TEL, 'tel');
            $this->create_var(self::EXPEDITEUR_EMAIL, 'email');
            $this->create_var(self::EXPEDITEUR_TELPORT, 'telport');
            $this->create_var(self::UNITE_POIDS, 'Kg');
            $this->create_var(self::ASSURE_COLIS, 'non');
        }

        private function create_var($nom, $valeur) 
        {
            $var = new Variable();

            if ($var->charger($nom)) 
            {
                $var->valeur = $valeur;
                $var->maj();
            }
            else 
            {
                $var->nom = $nom;
                $var->valeur = $valeur;
                $var->cache = 1;
                $var->protege = 1;
                $var->add();
            }
        }

        public function charger_commande($commande) 
        {
            return $this->getVars("select * from $this->table where commande=".intval($commande));
        }

        public function charger_id($id) 
        {
            return $this->getVars("select * from $this->table where id=".intval($id));
        }

        function action()
        {
            global $res;

            if(isset($_REQUEST['action_form']) && $_REQUEST['action_form'] == 'choix_relay')
            {
                $id_pr = $_REQUEST['choix'];
                $xml = $this->getInfosRelai($id_pr);
                $_SESSION['icirelais']->code = $id_pr;
                $_SESSION['icirelais']->nom = (string)$xml->PUDO_ITEMS->PUDO_ITEM->NAME;
                $_SESSION['icirelais']->adresse = (string)$xml->PUDO_ITEMS->PUDO_ITEM->ADDRESS1;
                $_SESSION['icirelais']->cpostal = (string)$xml->PUDO_ITEMS->PUDO_ITEM->ZIPCODE;
                $_SESSION['icirelais']->ville = (string)$xml->PUDO_ITEMS->PUDO_ITEM->CITY;
            }

            $client = new Client();
            $client->charger_id($_SESSION['navig']->client->id);

            if(isset($_REQUEST['action_cpostal']) && $_REQUEST['action_cpostal'] == 'recherche_cpostal')
            {
                $cpostal = $_REQUEST['cpostal'];
                $ville = $_REQUEST['ville'];
                $res = str_replace("#ADRESSE_GEOLOC", $cpostal . ' ' . $ville, $res);
            }


            if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'modadresse' && $_REQUEST['adresse'] != 0)
            {
                $new_adresse = new Adresse();
                $new_adresse->charger($_REQUEST['adresse']);
                $res = str_replace("#ADRESSE_GEOLOC", $new_adresse->adresse1 . ' ' . $new_adresse->cpostal . ' ' . $new_adresse->ville, $res);
            }
            else
            {
                $res = str_replace("#ADRESSE_GEOLOC", $client->adresse1 . ' ' . $client->cpostal . ' ' . $client->ville, $res);
            }

        }

        function aprescommande($commande)
        {
            $module = new Modules();
            $module->charger('icirelais');

            if($commande->transport == $module->id && isset($_SESSION['icirelais']))
            {
                $this->commande = $commande->id;
                $this->client = $_SESSION['navig']->client->id;
                $this->code_point = $_SESSION['icirelais']->code;
                $this->nom_point = $_SESSION['icirelais']->nom;
                $this->adresse_point = $_SESSION['icirelais']->adresse;
                $this->cpostal_point = $_SESSION['icirelais']->cpostal;
                $this->ville_point = $_SESSION['icirelais']->ville;
                $this->add();

                $adr = new Venteadr();

                if ($adr->charger($commande->adrlivr)) 
                {
                    $adr->nom = $_SESSION['icirelais']->nom;
                    $adr->prenom = "Point relais Icirelais " . $_SESSION['icirelais']->code;
                    $adr->adresse1 = $_SESSION['icirelais']->adresse;
                    $adr->adresse2 = "";
                    $adr->adresse3 = "";
                    $adr->cpostal = $_SESSION['icirelais']->cpostal;
                    $adr->ville = $_SESSION['icirelais']->ville;
                    $adr->tel = "";
                    $adr->maj();
                }
                unset($_SESSION['icirelais']);
            }
        }

        function boucle($texte, $args)
        {
            $boucle = lireTag($args, "boucle");
            if($boucle == "lst_relay")
            {
                return $this->boucle_lst_relay($texte, $args);				
            }
            if($boucle == "relay")
            {
                return $this->boucle_relay($texte, $args);	
            }
            if($boucle == "horaires")
            {
                return $this->boucle_horaires($texte, $args);
            }
        }

        function boucle_lst_relay($texte, $args)
        {
            $num = lireTag($args, "num");

            $adresse_active = lireTag($args, "adresse");
            if(!$adresse_active)
            {
                $ville = $_SESSION['navig']->client->ville;
                $ville = str_replace('-','%',$ville);
                $ville = str_replace(' ','%',$ville);

                $cpostal = $_SESSION['navig']->client->cpostal;

                $adresse = $_SESSION['navig']->client->adresse1;
                $adresse = str_replace(' ','%',$adresse);
            }
            elseif($adresse_active != 0)
            {
                $new_adresse = new Adresse();
                if($new_adresse->charger($adresse_active)){
                        $ville = $new_adresse->ville;
                        $ville = str_replace('-','%',$ville);
                        $ville = str_replace(' ','%',$ville);

                        $cpostal = $new_adresse->cpostal;

                        $adresse = $new_adresse->adresse1;
                        $adresse = str_replace(' ','%',$adresse);
                }
            }

            if(isset($_REQUEST['action_cpostal']) && $_REQUEST['action_cpostal'] == 'recherche_cpostal')
            {
                $cpostal = $_REQUEST['cpostal'];
                $ville = $_REQUEST['ville'];
            }

            $dateliv = date('d/m/Y');
            $requestID = 1234;

            $ville = str_replace(" ", "%", $ville);
            $adresse = str_replace(" ", "%", $adresse);
            
            if($xml_string = file_get_contents("http://exapaq.pickup-services.com/Exapaq/mypudofull.asmx/GetPudoList?address=$adresse&zipCode=$cpostal&city=$ville&request_id=$requestID&date_from=$dateliv"))
            {
                $xml_string = str_replace('%', '', $xml_string);
                $xml = new SimpleXMLElement($xml_string);
            }
            else
            {
                exit;
            }

            $i = 0;
            foreach ($xml->PUDO_ITEMS->PUDO_ITEM as $point_relai)
            { 
                $latitude = str_replace(',', '.', $point_relai->LATITUDE);
                $longitude = str_replace(',', '.', $point_relai->LONGITUDE);
                
                $nompr = str_replace("'", " ", $point_relai->NAME);
                $nompr = str_replace("\"", " ", $nompr);
                
                $villepr = str_replace("'", " ", $point_relai->CITY);
                $villepr = str_replace("\"", " ", $villepr);
                
                $addressepr = str_replace("'", " ", $point_relai->ADDRESS1);
                $addressepr = str_replace("\"", " ", $addressepr);
                
                $temp = str_replace("#NOM", $nompr, $texte);
                $temp = str_replace("#CPOSTAL", $point_relai->ZIPCODE, $temp);
                $temp = str_replace("#VILLE", $villepr, $temp);
                $temp = str_replace("#ADRESSE", $addressepr, $temp);
                $temp = str_replace("#CODE", $point_relai->PUDO_ID, $temp);
                $temp = str_replace("#LATITUDE", $latitude, $temp);
                $temp = str_replace("#LONGITUDE", $longitude, $temp);
                $temp = str_replace("#DISTANCE", 'à ' . $point_relai->DISTANCE . ' mètres', $temp);

                $res .= $temp;
                $i++;
                if($num) if($i == $num) break;
            }
            return $res;
        }

        function boucle_relay($texte, $args)
        {
            $id_pr = lireTag($args, 'id');

            if(!$xml = $this->getInfosRelai($id_pr)) exit;

            $res = $texte;

            $res = str_replace("#CODE", $xml->PUDO_ITEMS->PUDO_ITEM->PUDO_ID, $res);
            $res = str_replace("#NOM", $xml->PUDO_ITEMS->PUDO_ITEM->NAME, $res);
            $res = str_replace("#ADRESSE", $xml->PUDO_ITEMS->PUDO_ITEM->ADDRESS1, $res);
            $res = str_replace("#CPOSTAL", $xml->PUDO_ITEMS->PUDO_ITEM->ZIPCODE, $res);
            $res = str_replace("#VILLE", $xml->PUDO_ITEMS->PUDO_ITEM->CITY, $res);

            return $res;
        }

        function boucle_horaires($texte, $args)
        {
            $id_pr = lireTag($args, 'id');
            
            $xml = $this->getInfosRelai($id_pr);
			if(!$xml->ERROR)
			{		
				foreach($xml->PUDO_ITEMS->PUDO_ITEM->OPENING_HOURS_ITEMS->OPENING_HOURS_ITEM as $day)
				{
					$temp = str_replace('#JOUR_NUM', $day->DAY_ID, $texte);
					$temp = str_replace('#JOUR_TEXTE', $this->days["$day->DAY_ID"], $temp);
					$temp = str_replace('#OUVERTURE', $day->START_TM, $temp);
					$temp = str_replace('#FERMETURE', $day->END_TM, $temp);
	
					$res .= $temp;
					
					Tlog::fatal('Jour : ', $day);
				}
				return $res;
			}
        }

        public function getInfosRelai($id_pr)
        {
            if($xml_string = file_get_contents("http://exapaq.pickup-services.com/Exapaq/mypudofull.asmx/GetPudoDetails?pudo_id=$id_pr"))
            {
                $xml = new SimpleXMLElement($xml_string);
                return $xml;
            }
        }

        public function calcule()
        {
            if ($this->poids <= 0.25) return 5.16;
            else if ($this->poids <= 0.5) return 5.59;
            else if ($this->poids <= 1) return 5.89;
            else if ($this->poids <= 2) return 6.19;
            else if ($this->poids <= 3) return 6.51;
            else if ($this->poids <= 5) return 7.15;
            else if ($this->poids <= 6) return 7.52;
            else if ($this->poids <= 7) return 7.89;
            else if ($this->poids <= 8) return 8.26;
            else if ($this->poids <= 9) return 8.63;
            else if ($this->poids <= 10) return 9;
            else if ($this->poids <= 11) return 9.40;
            else if ($this->poids <= 12) return 9.79;
            else if ($this->poids <= 13) return 10.20;
            else if ($this->poids <= 14) return 10.62;
            else if ($this->poids <= 15) return 11.05;
            else if ($this->poids <= 16) return 11.55;
            else if ($this->poids <= 17) return 12.05;
            else if ($this->poids <= 18) return 12.55;
            else if ($this->poids <= 19) return 13.05;
            else if ($this->poids <= 20) return 13.55;
        }

        // FONCTION POUR LE FICHIER D'EXPORT BY Maitre eroudeix@openstudio.fr
        static function harmonise($valeur, $type, $longueur)
        {
            switch($type)
            {
                case 'numerique':
                    $valeur = (string)$valeur;
                    if(mb_strlen($valeur, 'utf8') > $longueur);
                        $valeur = substr($valeur, 0, $longueur);
                    for($i = mb_strlen($valeur, 'utf8'); $i < $longueur; $i++)
                    {
                        $valeur = '0' . $valeur;
                    }
                    break;
                case 'alpha_numerique':
                    $valeur = (string)$valeur;
                    if(mb_strlen($valeur, 'utf8') > $longueur);
                        $valeur = substr($valeur, 0, $longueur);
                    for($i = mb_strlen($valeur, 'utf8'); $i < $longueur; $i++)
                    {
                        $valeur .= ' ';
                    }
                    break;
            }

            return $valeur;
        }
    }

    include_once(realpath(dirname(__FILE__)) . "/classes/AdmIcirelais.class.php");
?>